﻿// <auto-generated />

using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;

namespace TheTrader.EntityFramework.Migrations
{
    [DbContext(typeof(TheTraderDbContext))]
    internal partial class TheTraderDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder.HasAnnotation("ProductVersion", "3.1.11")
                        .HasAnnotation("Relational:MaxIdentifierLength", 128)
                        .HasAnnotation(
                            "SqlServer:ValueGenerationStrategy",
                            SqlServerValueGenerationStrategy.IdentityColumn
                        );

            modelBuilder.Entity(
                "TheTrader.Domain.Models.Account",
                b =>
                {
                    b.Property<int>("Id")
                     .ValueGeneratedOnAdd()
                     .HasColumnType("int")
                     .HasAnnotation(
                         "SqlServer:ValueGenerationStrategy",
                         SqlServerValueGenerationStrategy.IdentityColumn
                     );

                    b.Property<int?>("AccountHolderId").HasColumnType("int");

                    b.Property<double>("Balance").HasColumnType("float");

                    b.HasKey("Id");

                    b.HasIndex("AccountHolderId");

                    b.ToTable("Accounts");
                }
            );

            modelBuilder.Entity(
                "TheTrader.Domain.Models.AssetTransaction",
                b =>
                {
                    b.Property<int>("Id")
                     .ValueGeneratedOnAdd()
                     .HasColumnType("int")
                     .HasAnnotation(
                         "SqlServer:ValueGenerationStrategy",
                         SqlServerValueGenerationStrategy.IdentityColumn
                     );

                    b.Property<int?>("AccountId").HasColumnType("int");

                    b.Property<DateTime>("DateProcessed").HasColumnType("datetime2");

                    b.Property<bool>("IsPurchase").HasColumnType("bit");

                    b.Property<int>("Shares").HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("AccountId");

                    b.ToTable("AssetTransactions");
                }
            );

            modelBuilder.Entity(
                "TheTrader.Domain.Models.User",
                b =>
                {
                    b.Property<int>("Id")
                     .ValueGeneratedOnAdd()
                     .HasColumnType("int")
                     .HasAnnotation(
                         "SqlServer:ValueGenerationStrategy",
                         SqlServerValueGenerationStrategy.IdentityColumn
                     );

                    b.Property<DateTime>("DateJoined").HasColumnType("datetime2");

                    b.Property<string>("Email").HasColumnType("nvarchar(max)");

                    b.Property<string>("Password").HasColumnType("nvarchar(max)");

                    b.Property<string>("Username").HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Users");
                }
            );

            modelBuilder.Entity(
                "TheTrader.Domain.Models.Account",
                b =>
                {
                    b.HasOne("TheTrader.Domain.Models.User", "AccountHolder")
                     .WithMany()
                     .HasForeignKey("AccountHolderId");
                }
            );

            modelBuilder.Entity(
                "TheTrader.Domain.Models.AssetTransaction",
                b =>
                {
                    b.HasOne("TheTrader.Domain.Models.Account", "Account")
                     .WithMany("AssetTransactions")
                     .HasForeignKey("AccountId");

                    b.OwnsOne(
                        "TheTrader.Domain.Models.Stock",
                        "Stock",
                        b1 =>
                        {
                            b1.Property<int>("AssetTransactionId")
                              .ValueGeneratedOnAdd()
                              .HasColumnType("int")
                              .HasAnnotation(
                                  "SqlServer:ValueGenerationStrategy",
                                  SqlServerValueGenerationStrategy.IdentityColumn
                              );

                            b1.Property<double>("PricePerShare").HasColumnType("float");

                            b1.Property<string>("Symbol").HasColumnType("nvarchar(max)");

                            b1.HasKey("AssetTransactionId");

                            b1.ToTable("AssetTransactions");

                            b1.WithOwner().HasForeignKey("AssetTransactionId");
                        }
                    );
                }
            );
#pragma warning restore 612, 618
        }
    }
}
